
■ JoyToKey 更新履歴
￣￣￣￣￣￣￣￣￣￣

◇Ver5.6
・キーボード入力２の設定を拡張しました。
  * 一度に４つまでのキー入力定義をサポート
  * ４種類の入力定義をローテーションする機能をサポート
  * 連射機能・トグル機能をサポート

・使用ライブラリを DirectX 7 から DirectX 8 へ更新しました。


◇Ver5.5.x
・バグフィックス


◇Ver5.5
・ボタン番号の割り当て・組み合わせ機能

　例えば簡単な使用例としては、ジョイスティックを買い替えレイアウトが
　変わった場合には、仮想的にボタン番号を入れ替えることができます。

　また、使用されていない後半のボタン番号を設定することで、一つのボタン
　に複数の機能を割り当てたりできます。（例えば Button1 が押されたら、
　Button21 も押されたことにし、両方の処理を実行させる）

　さらに、ボタンの同時押しに対する機能を定義することも可能です。
　（例えば Button5 と Button6 が同時に押された場合に、Button22 が押さ
　れた処理を実行させ、Button5 と Button6 の処理は実行しない）

・一時的にジョイスティック番号を切り替えた時や、設定ファイルが切り替わっ
　た時に、もともと押されていたボタン入力を一定時間（もしくは一度離され
　るまで）入力を無視する設定を可能にしました。

　例えばアプリケーションを切り替えるために、Alt+Tab が割り当てられた
　ボタンを押した場合、切り替え直後に Alt+Tab が再度処理され元のアプリ
　ケーションに戻ってしまうことを防げます。

・マウスのカーソル移動とクリックを一つのボタンに同時割り当てした際に、
　クリック＆ホールドの方が先に処理されるようにしました。

・スリープ・休止状態から復帰時の処理を改善しました。

・設定項目を、メニューから独立したウィンドウに移行しました。

・押されているボタンをハイライトする時に、選択されているジョイスティッ
　ク番号に関わらず、どのタブでもハイライト表示されるようにしました。
　そのかわり、実際に押されたジョイスティック番号によって、ハイライト
　色を変えるようにしました。

・表示、設定するボタンの数を指定できるようにしました。

・設定ファイルを Unicode (UTF8+BOM) で保存するようにしました。
　ＰＣの言語とは異なる言語のファイル名・コメントなどを使用できます。。

・（上級者向け機能）
　特殊な状況で、"JoyToKey.ini" ファイルの場所だけ無理やり固定して使用
　したい場合（例えば Hyperlaunch などの launcher を使用している場合）、
　レジストリに隠し設定を入れてサポートできるようにしました。
　
  1. レジストリ エディターを起動 (ファイル名を指定して実行 "regedit")
  2. "HKEY_CURRENT_USER\Software\JoyToKey" というキーを作成
  3. その中に、IniFilePath という文字列の値を作成し、任意のパスを指定
     "IniFilePath=c:\Whatever\Path\JoyToKey.ini"


◇Ver5.4.1
・設定ファイルが切り替わった際のサウンド通知に、WAV ファイルだけでなく
  mp3 形式など、他のファイル形式にも対応しました。


◇Ver5.4
・設定ファイルが切り替わった際に、タスクトレイのバルーンで通知したり、
　サウンドを鳴らして通知したりできるようにしました。

　バルーン表示はメニューの設定から、サウンド指定は "Options" タブから
　設定できます。（WAV ファイルのみ）

　サウンドは設定ファイルごとに指定できるため、例えば、視覚障害のある方
　が、特別なスイッチと JoyToKey を組み合わせて使用している場合に、音で
　切り替えを判断することが可能になります。

・設定ファイルのファイルサイズをコンパクトにしました。
  （何も設定されていないボタンの詳細は省略する仕様にしました）

・設定ファイル、またはフォルダが読み取り専用になっている場合、自動的に
　読み取り専用を解除するようにしました。


◇Ver5.3.2
・小さな不具合修正


◇Ver5.3.1
・ホームページが http://joytokey.net/ に移行されました。


◇Ver5.3
・ボタンを押して設定ファイルを切り替える機能で、何秒か押されてるのを
　待ってから切り替える機能を追加しました。ジョイスティックをネイティブ
　にサポートされているゲームなどをプレイ中、通常は空の設定ファイルを
　選択してJoyToKeyを無効状態にしておき、切り替え用のボタンを何秒か押し
　た時のみ、メインの設定ファイルに戻らせる、といった使い方ができます。

・JoyToKeyのメインウィンドウがアクティブになっている時も、押されている
　ボタンの入力処理を行うことが可能なようにしました。
　（「設定」→「バックグラウンド時のみ入力処理させる」をオフにする）


◇Ver5.2.3
・５ボタンマウスの、第４ボタン・第５ボタンクリックをサポートしました。
　マウスジェスチャーをジョイスティックで使いたい方はお試しください。

・倍速処理モードで、最大１６倍速まで対応しました。
　（ただし、これはあくまで実験的なもので、ＣＰＵにかかる負荷もかなり
　　大きくなるので、通常利用では全くお勧めいたしません）

・その他、細かいバグフィクス


◇Ver5.2.2
・メニューに、「設定ファイルのフォルダを開く」を追加しました。

・設定ファイルが共用 AppData フォルダに存在する場合、そこから読み込み
　することも可能になりました。
　例えば、C:\ProgramData\JoyToKey フォルダに JoyToKey.ini という空の
　ファイルを作成しておけば、設定ファイルを複数のユーザで共有したり、
　JoyToKey.exe を書き込み不可のフォルダから起動したりすることができます。

・デバッグログ情報を追加しました。
　（巨大になるので通常は作成しないでください）


◇Ver5.2.0
・キーボードエミュレーションで、マウスのクリックも組み合わせられるよう
　にしました。例えば、「CTRL＋左クリック」を割り当てることができます。

　クリックを割り当てるには、入力ボックスを右クリックし、メニューから
　指定してください。

・マインクラフトで左SHIFTキーが効かなかったバグを修正


◇Ver5.1.2
・SHIFTキーとカーソルキーの組み合わせで、範囲指定（複数選択）がうまく
　行われていなかったバグを修正しました。

・その他細かなバグ修正


◇Ver5.1.1
・マウスのカーソル移動をアナログスティック入力に応じて加速する機能で、
　より滑らかにコントロールできるよう加速関数の形を微調整し、また最大
　50倍まで指定できるようにしました。


◇Ver5.1.0
・アナログスティックでマウスのカーソル移動を操作する際、しきい値をなくし
　なめらかに加速するようにしました。

・アナログスティックが複数あり、軸の自動検出がおかしい場合に、軸の割り
　当てを手動で変更できるようにしました。
　（メニュー：「設定」→「ジョイスティックの調整」）

・ジョイスティックを複数接続した際に、通常は Windows に認識された順番に
  Joystick 1, 2, 3, ... と番号が振られますが、特定のデバイスを常に指定
　の番号に割り当てられるようにしました。
　（メニュー：「設定」→「ジョイスティックの調整」）

・お支払い方法として Digital River 社の share*it! を追加しました。

・その他細かなバグ修正


◇Ver5.0.3
・スリープ状態から復帰時に、ジョイスティックを再検出するようにしました。


◇Ver5.0.2
・設定の「押されているボタンをハイライト表示する」が保存されないバグを
　修正しました。


◇Ver5.0.1
・メニューに「ヘルプ→簡単な使い方」を追加しました。

・ボタンを変更
　（「すべての設定をクリア」ボタンの代わりに、「このボタン設定を編集」）

・バグ修正


◇Ver5.0
・アナログスティック入力で、入力の大小によってボタン割り当てを切り替えら
　れるようにしました。

・その他にも、キーボード入力の種類をいろいろ増やしました。例えば、
　押すたびに「Ａ→Ｂ→Ｃ→Ａ→Ｂ→Ｃ」と切り替わるようなボタン設定や、
　ボタンを押した長さによって、ＡとＢが切り替わるような設定が可能になり
　ました。

・自動連射機能のスピードを、自由に指定できるようにしました。例えば、
　「一秒間に 1.5 回」や「123.4 秒に一回」など自由に指定できます。
　（ただし、内部処理の精度の限界を超えた細かい指定をしても無視されます）

・キー入力を自動連射する際に、最初の一定時間は連射させずに、遅らせて連射
　できるようにしました。これにより、カーソルキーの移動などを、キーボード
　を使った場合の動作に似せることが設定できます。

・JoyToKey のメイン画面では、デフォルトではジョイスティックが押されても
　割り当ててあるボタンの機能を実行しないようにし、その代わりに押されてい
　るボタンをハイライトして確認できるようにしました。

・ウィンドウを最小化した時に、デフォルトではアイコンをタスクバーに残す
　ようにしました。従来通りタスクバーから隠したい場合には、メニューの設定
　から変更できます。

・各ボタン割り当てに、コメントを追加できるようにしました。これによって
　「しゃがむ」「○○を開く」など、意図を分かりやすいようにメモできます。

・ジョイスティック設定のコピーをサポートしました。
　（例えば「ジョイスティック１」の設定を「ジョイスティック３」にコピー）
　メイン画面のジョイスティック番号の選択タブ付近で、右クリックメニュー
　から設定のコピー・クリアができます。

・マウスカーソルの移動量を一時的に調整する機能を、特殊機能設定から、
　通常のマウス設定のページに移動しました。これによって、一つのボタンで、
　カーソルスピード調整しつつ右クリックも押すなどの設定ができます。

・キーボード割り当てで、最大４つのキーの組み合わせまで指定できるように
　しました。

・IME ON/OFF 設定とは別に、「半角」「全角」キーを割り当てられるように
　しました。（一部のオンラインゲームで使用されているようです）

・他にもさまざまな小さな不具合を修正しました。
　（例えば、マウスボタンを一秒一回以下の遅い自動連射設定にした場合に、
　　表示が OFF になってしまっていた件や、ＰＣ起動時に管理者権限で自動
　　スタートするようにWindows 付属のタスクスケジューラに手動で設定しても
　　うまく動作しなかった件など）


◇Ver4.6.1
・マウスボタンを一秒一回以下の遅い自動連射設定にした場合に、表示が OFF に
　なってしまう不具合を修正しました。

・Windows 付属の「タスク スケジューラ」からの起動をサポートしました。
　これにより、Windows 起動時に管理者権限で自動的にスタートするように
　設定することが可能になりました。


◇Ver4.6
・「一時的に他のジョイスティック番号を使う」機能で、切り替える瞬間に
　もともと押されていたボタン設定と切り替え後のボタン設定が同じだった
　場合、入力を継続させるようにしました。
　（前のバージョンまでは、一度キーを離し、再度押す処理になっていました）

・アプリケーションとの関連付け機能で、関連されていないアプリケーション
　に切り替わった際にどうするかを選べるようにしました。


◇Ver4.5.3
・メニューに「設定ファイルの上書き保存」と「ジョイスティックの調整」を追加

◇Ver4.5.2
・バグ修正：Ver4.3 で追加された、アプリケーションとの関連付け機能で、
　64 bit のアプリケーションだとうまく動作しないのを修正しました。

◇Ver4.5.1
・バグ修正：Ver4.5 で追加された、アナログスティックでマウスのカーソル
　移動を加速させる機能で、斜め方向への入力をスムーズにしました。

◇Ver4.5
・アナログスティックでマウスのカーソル移動を操作する際、あるしきい値
　（例えば９５％）を超えたら加速させる機能を追加しました。

・アプリケーションとの関連付け機能で、そのアプリから離れた時には、
　その前最後に使っていた設定ファイルに戻るようにしました。
　（ただし JoyToKey に切り替えた場合を除く）

◇Ver4.4
・ＰＯＶ入力処理を、４方向処理と８方向処理で選べるようにしました。

・アナログスティック入力処理で、入力のしきい値を左右のスティックで個別に
　設定できるようにしました。（正確にはスティック１とその他で別に設定可）

・ボタンの表示設定モードを細かく選べるようにしました。

・内部の入力処理を２倍速で行うモードをサポートしました。ジョイスティック
　入力からのタイムラグを平均半分以下にし、また最大毎秒６０回の連射が可能
　になります。（ただし、連射設定表示などの見た目は通常のまま変わりません。
　また、ＣＰＵ負荷が増えます）

・デバッグ用のログファイルを出力するモードを追加しました。ただし、通常は
　使う必要はありません。

・「一時的に他のジョイスティック番号を使う」の機能のバグを一部修正。

◇Ver4.3
・アプリケーションによって設定ファイルを関連付けできるようにしました。
　事前に関連付けを設定しておけば、ターゲットのアプリケーションが切り替わ
　るたびに自動的に JoyToKey の設定ファイルも切り替えることができます。
　（メニュー：「設定」→「アプリケーションとの関連付け」）

・ＰＯＶ入力で８方向に対して設定できるようにしました（従来は４方向）

・ものすごく遅く自動連射できるようにしました（最大１５分に１回押すペース）

・メインメニュー及びタスクトレーメニューから、JoyToKey の機能を一時的に
　停止（無効化）できるようにしました。

・設定ファイルのコピーを簡単に行えるようにしました。
　（右クリックメニュー、及び、メインメニューの「ファイル」より）

・ウィンドウのサイズを可変にしました。

◇Ver4.2
・ウィンドウ右上の終了ボタン"×"を押したとき、デフォルトで終了してしまう
　かわりに最小化するよう変更しました。また、旧バージョンと同様終了するこ
　とも選べるようにしました。（設定メニューから変更可能）

・ボタンを押すたびに、押された状態と離された状態をトグルで切り替える機能
　を追加しました。（例えばマウスエミュレーションでドラッグ＆ドロップに使っ
　たり、自動連射機能と合わせて一度押せばずっと連射状態にしたりできます）

・タスクトレイアイコンを左クリックすることで、ウィンドウを開いたり閉じたり
　できるようにしました。（右クリックは今までどおりメニューが表示されます）

・コマンドラインで設定ファイルを指定して起動した場合、１つ目の JoyToKey
　の場合は単純にそのファイルを使用して起動しますが、既に他に JoyToKey が
　走っていた場合にはそちらの設定ファイルを自動で切り替えて、新しいプロセ
　スはそのまま多重起動せずに終了する機能を追加しました。

◇Ver4.1
・ショートカットで「実行時の大きさ＝最小化」を指定して起動する際にうまく
　最小化されない不具合を直しました。
・PayPal からの支払いにも対応しました。

◇Ver4.0
・シェアウエアソフトになりました。
・スタートアップ時にジョイスティックがつながっていなくても起動するように
　しました。後で使うときにジョイスティックをつなげば自動的に検出します。
　（２本目以降は自動では検出しないので、「再検出」ボタンを押してください）
・キーボード入力のエミュレーション方法を数種類から選べるようにしました。
　方法を試しに切り替えることによって、もしかしたら今まで動作していなかった
　ソフトを操作できるようになるかもしれません。
・非常に遅く連射する機能（例えば５秒に１回）を追加しました。

◇Ver3.7.9
・Bug Fix: 3.7.8 で変更された終了時の動作を元に戻し、Windows の終了時
　に影響を与えないようにした。

◇Ver3.7.8
・「アイコン化して起動」時に、一瞬ウィンドウが表示されるのを抑制した。
・ウィンドウ右上の終了ボタン"×"を押したとき、終了してしまうかわりに
　最小化するようにした。

◇Ver3.7.7
・BUG FIX: 「他の設定ファイルに切り替える」でハングすることがあった。

◇Ver3.7.6
・"Print Screen" キーを特殊なボタンの割り当てで選べるようにしました。

◇Ver3.7.5
・町田さんの「でき」シリーズへの対応を強化。外部アプリケーションから、
　設定ファイルの切り替えを指示できるようにインターフェースを用意しました。

◇Ver3.7.4
・Windows 2000 以降 (XP も含む) の環境では、DirectInput を使用している
　アプリケーションにも一部対応しました。

・リストから R-Shift, L-Shift, R-Ctrl, ... 等を選ぶことにより、左右の
　Shift, Ctrl, Alt キーを区別できるようにしました。
（L-Shift, R-Shift, Shift(従来のもの：普通にキーを押す) の３つの中から
　意図されているキーを正しく選ばないと動作しませんので、注意！）

◇Ver3.7.3
・タスクトレイのアイコンを右クリックした際に、設定ファイル一覧を展開
　して表示するようにし、切り替えを１ステップで選べるようにしました。

◇Ver3.7.2
・漢字入力 (IME) の ON/OFF を割り当てられるようにしました。

◇Ver3.7.1
・「できボタン＋。」とのインターフェース仕様を変更いたしました。

◇Ver3.7
・坂戸パソコンボランティアの町田さん作の「できボタン＋。」に対応しました。

・POV（ハットスイッチ）をサポートしました。

・「特殊機能」として、「他の設定ファイルに切り替える」をサポートしました。

・起動時に、コマンドラインオプションから、設定ファイルを指定できるように
　しました。（ただし同一フォルダ内に存在する設定ファイルに限ります）
　これにより、使用する用途ごとに（プレゼン、ゲーム１、ゲーム２･･･のように）
　ショートカットを分けて用意することが可能になりました。

・タスクトレイでアイコン化した状態のままで、アイコンをクリックして、
　メニューから設定ファイルを切り替えられるようにしました。

・アナログ入力のできるジョイスティックにおいて、
　Dead Zone（中心付近で、入力を検知しない領域）
　Saturation（周辺付近で、これ以上は入力を変化させない領域）
　などを、"JoyToKey.ini" を編集することにより設定できるようにしました。

  AnalogDeadZone (0 〜 10000 の範囲, default 1000)
  AnalogSaturation (0 〜 10000 の範囲, default 10000)

　従来、アナログ入力でマウスカーソルを操作する場合に、しきい値を設けて
　中心付近の多少の入力を無視できるようにしていましたが、今後は、
　しきい値は０のままで、その代わりに AnalogDeadZone の値を上げたほうが、
　滑らかに操作できるものと思われます。

・「特殊機能」の「一時的に他のジョイスティック番号の設定を使う」で、
　番号切り替え後に、直前のジョイスティック番号の入力信号が、たまに
　押されたまま残ってしまうことがある、というバグを修正いたしました。


◇Ver3.6
・マウスのボタンに対しても、連射機能をサポートしました。
（マウスボタンのみに作用し、マウスカーソルの操作には影響ありません）

◇Ver3.5
・アイコン化した状態で起動できるようにしました。
・（プログラム上で）設定ファイル名の名称を変更できるようにしました。
・長時間起動したままにしておくと、ちょっとずつ処理が重くなっていくバグを
　修正しました（←かなり悪質なバグでしたね・・・。本当にすいません）

◇Ver3.4
・入力のしきい値（あそび）を設定できるようにしました。

◇Ver3.3
・TAB, ALT, CTRL などの設定方法を少々変更しました。
・一時的に使用する設定を変更する、特殊機能を付け加えました。
・久しぶりに英語版も作りました
（実は上記の新機能は海外ユーザさんからの要望だったもので･･･(笑)）

◇Ver3.2
・多重起動を制御できるようにしました。

◇Ver3.1
・設定ファイルでの Windows 用、MS-DOS 用という区別をなくしました。
・ポップアップメニューを追加しました。

◇Ver3.0
・最大８軸（６軸＋スライダー×２軸）まで設定できるようにしました。
・斜め入力をボタン２９〜３２とは独立させました。
・設定ファイルごとにジョイスティック数を変えられるようにしました。
・連射機能、マウス移動、ホイール機能などを改良しました。
・マウス移動、ホイール回転の加速、減速を行う特殊なボタンをサポートしました。
・これらにともない、設定ファイルの互換性がなくなってしまいました。

◇Ver2.2
・アナログ入力に比例したマウスの移動をできるようにしました。
・IntelliMouse のホイール機能をエミュレートできるようにしました。
 （少々動作が怪しい）

◇Ver2.1
・Button29 〜 Button32 の設定を使って、斜め入力に対して固有のキーを
　割り当てられるようにしました。

◇Ver2.0
・ＧＵＩ画面を変更しました。
・簡易設定ウィザード（あまり便利でない）を追加しました。
・前のバージョンとのデータ互換性がなくなりました（すいません）。

◇Ver1.0
・最初のリリース
・英語版も作成しました。
